﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;
using Com.Piwigo.Wpf.Helper;
using Com.Piwigo.Wpf.DTO;

namespace Com.Piwigo.Wpf.Command
{
    public abstract class PwgCmdBase : ICommand
    {
       Boolean _isRunning;
       public Boolean IsRunning {
           get
           {
               return _isRunning;
           }
           set
           {
               _isRunning = value;
           }
       }

       #region ICommand Membres
        public virtual bool CanExecute(object parameter)
        {
             Boolean retVal = false;
            if ( AppHelper.IsInDesignModeStatic == true)
            {
                retVal = false;
            }
            else
            {
                if (IsRunning)
                {
                    retVal = false;
                }
                else if (PwgModelManager.Instance.Session != null)
                {
                    retVal = !String.IsNullOrWhiteSpace(PwgModelManager.Instance.Session.ServeurName);                    
                }
            }
            return (retVal);
        }

        public abstract void Execute(object parameter);
       
        public event EventHandler CanExecuteChanged
        {
           add { CommandManager.RequerySuggested += value; }
           remove { CommandManager.RequerySuggested -= value; }
        }
       #endregion
    }
}
