﻿using System;
using System.Collections.Generic;
using Com.Piwigo.Lib.IService;
using Com.Piwigo.Wpf.DTO;
using Com.Piwigo.Lib.DTO;
using Com.Piwigo.Wpf.DTO.Helper;
using Com.Piwigo.Wpf.Helper;
using Com.Piwigo.Wpf.Service;

namespace Com.Piwigo.Wpf.Command
{
    public sealed class PwgCmdConnect : PwgCmdBase
    {
        public override void Execute(object parameter)
        {
            try {
                IsRunning = true;
                Uri uriServer = new Uri(PwgModelManager.Instance.Session.ServeurName);

                PwgServiceProvider.Instance.PwgSetupService.Setup(null, null, uriServer);
                PwgSession sess = PwgServiceProvider.Instance.PwgSessionService.GetPwgSession();
                sess = PwgServiceProvider.Instance.PwgSessionService.Login( PwgModelManager.Instance.Session.UserName,
                                                                            PwgModelManager.Instance.Session.Password);

                PwgSessionWPF sesWPF = PwgModelManager.Instance.Session;
                PwgSessionWPFHelper.AddPwgSessionInfoToPwgSessionWPF(sess, ref sesWPF);

                List<PwgCategory> lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetListOfCategory(null, false, null); //(PwgModelManager.Instance.Session.Status == PwgSessionStatusEnum.Guest)
                PwgCategoryListWPF lstCatWPF = PwgModelManager.Instance.CategoryList;

                PwgCategoryListWPFHelper.ConvertPwgCategoryListToPwgCategoryListWPF(lstCat, ref lstCatWPF);

                ImageCacheManager.Instance.SetCurrentServer(uriServer.AbsoluteUri);
                IsRunning = false;
            }
            catch (PwgServiceException ex)
            {
                Console.WriteLine("Erreur " + ex.NumeroErr + " " + ex.MessageErr);
                Console.WriteLine(ex.Message);
            }

        }
    }
}
